/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.82 by cnh, Wed Jun 30 01:19:29 2004 UTC revision 1.162 by jmc, Sat May 5 20:18:52 2007 UTC
# Line 1  Line 1 
1  #! /usr/bin/env sh  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg[ ]"
17      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg[ ]"
18      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg[ ]"
19      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg[ ]"
20        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg$"
21        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg$"
22        test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg$"
23        test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg$"
24  }  }
25    
26  # Search for particular CPP #cmds associated with MPI  # Search for particular CPP #cmds associated with MPI
27  # usage: test_for_mpi_in_cpp_eeoptions CPP_file  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
28  test_for_mpi_in_cpp_eeoptions() {  test_for_mpi_in_cpp_eeoptions() {
29      cpp_options=$1      cpp_options=$1
30      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI[ ]"
31      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI[ ]"
32      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI[ ]"
33      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI[ ]"
34        test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI$"
35        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI$"
36        test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI$"
37        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI$"
38  }  }
39    
40  # Search for particular string in a file. Return 1 if detected, 0 if not  # Search for particular string in a file. Return 1 if detected, 0 if not
# Line 39  test_for_string_in_file() { Line 47  test_for_string_in_file() {
47      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
48          printf "Error: In $file there is an illegal line: "          printf "Error: In $file there is an illegal line: "
49          grep -i "$strng" $file          grep -i "$strng" $file
50          return 1          exit 99
51      fi      fi
52      return 0      return 0
53  }  }
# Line 122  EOF Line 130  EOF
130        stop        stop
131        end        end
132  EOF  EOF
133      test -e Makefile  &&  mv -f Makefile Makefile.bak      test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
134      cat <<EOF >> Makefile      cat <<EOF >> $MAKEFILE
 %.$tfs : %.F  
135  .SUFFIXES:  .SUFFIXES:
136  genmake_hello.$tfs: genmake_hello.F  .SUFFIXES: .$tfs .F
137          $LN genmake_hello.F genmake_hello.$tfs  .F.$tfs:
138            $LN \$< \$@
139  EOF  EOF
140      $MAKE "genmake_hello."$tfs > /dev/null 2>&1      $MAKE "genmake_hello."$tfs > /dev/null 2>&1
141      RETVAL=$?      RETVAL=$?
142      if test "x$RETVAL" != x0 -o ! -e "genmake_hello."$tfs ; then      if test "x$RETVAL" != x0 -o ! -f "genmake_hello."$tfs ; then
143          if test "x$FS" = x ; then          if test "x$FS" = x ; then
144              FS='for'              FS='for'
145              FS90='fr9'              FS90='fr9'
# Line 148  EOF Line 156  EOF
156              return              return
157          fi          fi
158      fi      fi
159      rm -f genmake_hello.* Makefile      rm -f genmake_hello.* $MAKEFILE
160      test -e Makefile  &&  mv -f Makefile.bak Makefile      test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
161    
162      #  If we make it here, use the extensions      #  If we make it here, use the extensions
163      FS=$tfs      FS=$tfs
# Line 158  EOF Line 166  EOF
166  }  }
167    
168    
169    look_for_makedepend()  {
170    
171        #  The "original" makedepend is part of the Imake system that is
172        #  most often distributed with XFree86 or with an XFree86 source
173        #  package.  As a result, many machines (eg. generic Linux) do not
174        #  have a system-default "makedepend" available.  For those
175        #  systems, we have two fall-back options:
176        #
177        #    1) a makedepend implementation shipped with the cyrus-imapd
178        #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/
179        #
180        #    2) a known-buggy xmakedpend shell script
181        #
182        #  So the choices are, in order:
183        #
184        #    1) use the user-specified program
185        #    2) use a system-wide default
186        #    3) locally build and use the cyrus implementation
187        #    4) fall back to the buggy local xmakedpend script
188        #
189        if test "x${MAKEDEPEND}" = x ; then
190            which makedepend > /dev/null 2>&1
191            RV0=$?
192            test -f $MAKEFILE  &&  mv -f $MAKEFILE $MAKEFILE".tst"
193            #  echo 'MAKEFILE="'$MAKEFILE'"'
194            cat <<EOF >> $MAKEFILE
195    #   THIS IS A TEST MAKEFILE GENERATED BY "genmake2"
196    #
197    #   Some "makedepend" implementations will die if they cannot
198    #   find a Makefile -- so this file is here to gives them an
199    #   empty one to find and parse.
200    EOF
201            cat <<EOF >> genmake_tc.f
202          program test
203          write(*,*) 'test'
204          stop
205          end
206    EOF
207            makedepend genmake_tc.f > /dev/null 2>&1
208            RV1=$?
209            test -f $MAKEFILE  &&  rm -f $MAKEFILE
210            test -f $MAKEFILE".tst"  &&  mv -f $MAKEFILE".tst" $MAKEFILE
211            if test "x${RV0}${RV1}" = x00 ; then
212                MAKEDEPEND=makedepend
213            else
214                echo "    a system-default makedepend was not found."
215                
216                #  Try to build the cyrus implementation
217                build_cyrus_makedepend
218                RETVAL=$?
219                if test "x$RETVAL" != x0 ; then
220                    MAKEDEPEND='$(TOOLSDIR)/xmakedepend'
221                fi
222                rm -f ./genmake_cy_md
223            fi
224        else
225            #  echo "MAKEDEPEND=${MAKEDEPEND}"
226            echo "${MAKEDEPEND}" | grep -i cyrus > /dev/null 2>&1
227            RETVAL=$?
228            if test x"$RETVAL" = x0 ; then
229                build_cyrus_makedepend
230            fi
231        fi
232    }
233    
234    
235    build_cyrus_makedepend()  {
236        rm -f ./genmake_cy_md
237        (
238            cd $ROOTDIR/tools/cyrus-imapd-makedepend  \
239                &&  ./configure > /dev/null 2>&1  \
240                &&  make > /dev/null 2>&1
241            if test -x ./makedepend.exe ; then
242                $LN ./makedepend.exe ./makedepend
243            fi
244            ./makedepend ifparser.c > /dev/null 2>&1  \
245                &&  echo "true"
246        ) > ./genmake_cy_md
247        grep true ./genmake_cy_md > /dev/null 2>&1
248        RETVAL=$?
249        rm -f ./genmake_cy_md
250        if test "x$RETVAL" = x0 ; then
251            MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'
252            return 0
253        else
254            echo "WARNING: unable to build cyrus-imapd-makedepend"
255            return 1
256        fi
257    }
258    
259    
260    build_embed_encode()
261    {
262        printf "  building the embed-encode utility...  "
263        if test ! -e "$ROOTDIR/tools/embed_encode/encode_files" ; then
264            if test ! -d "$ROOTDIR/tools/embed_encode" ; then
265                echo
266                echo "    Error: can't locate \"$ROOTDIR/tools/embed_encode\""
267                echo
268                EMBED_SRC=f
269                return 1
270            fi
271            clist="cc gcc c89 $CC"
272            for ic in $clist ; do
273                comm="$ic -o encode_files encode_files.c"
274                ( cd $ROOTDIR/tools/embed_encode && $comm ) > /dev/null 2>&1
275                RETVAL=$?
276                if test "x$RETVAL" = x0 ; then
277                    echo "OK"
278                    DEFINES="$DEFINES -DHAVE_EMBED_SRC"
279                    return 0
280                fi
281            done
282            echo
283            echo "    Error: unable to build $ROOTDIR/embed_encode/encode_files"
284            echo "      so it has been disabled"
285            echo
286            EMBED_SRC=f
287            return 1
288        fi
289        echo "OK"
290        DEFINES="$DEFINES -DHAVE_EMBED_SRC"
291    }
292    
293    
294  # Guess possible config options for this host  # Guess possible config options for this host
295  find_possible_configs()  {  find_possible_configs()  {
296    
# Line 188  find_possible_configs()  { Line 321  find_possible_configs()  {
321          CPP="cpp -traditional -P"          CPP="cpp -traditional -P"
322      fi      fi
323    
324      #  The "original" makedepend is part of the Imake system that is      look_for_makedepend
325      #  most often distributed with XFree86 or with an XFree86 source  
326      #  package.  As a result, many machines (eg. generic Linux) do not      #================================================================
327      #  have a system-default "makedepend" available.  For those      #  look for possible C compilers
328      #  systems, we have two fall-back options:      tmp="$MITGCM_CC $CC gcc c89 cc c99 mpicc icc"
329      #      p_CC=
330      #    1) a makedepend implementation shipped with the cyrus-imapd      for c in $tmp ; do
331      #       package:  ftp://ftp.andrew.cmu.edu/pub/cyrus-mail/          rm -f ./genmake_hello.c  ./genmake_hello
332      #          cat >> genmake_hello.c << EOF
333      #    2) a known-buggy xmakedpend shell script  #include <stdio.h>
334      #  int main(int argc, char **argv) {
335      #  So the choices are, in order:    printf("Hello!\n");
336      #    return 0;
337      #    1) use the user-specified program  }
     #    2) use a system-wide default  
     #    3) locally build and use the cyrus implementation  
     #    4) fall back to the buggy local xmakedpend script  
     #  
     if test "x${MAKEDEPEND}" = x ; then  
       which makedepend > /dev/null 2>&1  
       RV0=$?  
       cat <<EOF >> genmake_tc.f  
       program test  
       write(*,*) 'test'  
       stop  
       end  
338  EOF  EOF
339        makedepend genmake_tc.f > /dev/null 2>&1          $c -o genmake_hello genmake_hello.c > /dev/null 2>&1
340        RV1=$?          RETVAL=$?
341        if test ! "x${RV0}${RV1}" = x00 ; then          if test "x${RETVAL}" = x0 ; then
342           echo "    a system-default makedepend was not found."              p_CC="$p_CC $c"
343            fi
344           #  Try to build the cyrus impl      done
345           rm -f ./genmake_cy_md      rm -f ./genmake_hello.c ./genmake_hello
346           (      if test "x${p_CC}" = x ; then
347               cd $ROOTDIR/tools/cyrus-imapd-makedepend  \          cat 1>&2 <<EOF
348                   &&  ./configure > /dev/null 2>&1  \  
349                   &&  make > /dev/null 2>&1  Error: No C compilers were found in your path.  Please specify one using:
350               if test -x ./makedepend.exe ; then  
351                   $LN ./makedepend.exe ./makedepend      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
352               fi      2) the CC or MITGCM_CC environment variables.
353               ./makedepend ifparser.c > /dev/null 2>&1  \  
354                   &&  echo "true"  EOF
355           ) > ./genmake_cy_md          exit 1
356           grep true ./genmake_cy_md > /dev/null 2>&1      else
357           RETVAL=$?          echo "  The possible C compilers found in your path are:"
358           if test "x$RETVAL" = x0 ; then          echo "   "$p_CC
359               MAKEDEPEND='$(TOOLSDIR)/cyrus-imapd-makedepend/makedepend'          if test "x$CC" = x ; then
360           else              CC=`echo $p_CC | $AWK '{print $1}'`
361               MAKEDEPEND='$(TOOLSDIR)/xmakedepend'              echo "  Setting C compiler to: "$CC
362           fi          fi
          rm -f ./genmake_cy_md  
       fi  
363      fi      fi
364    
365      # look for possible fortran compilers      #================================================================
366      tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc f90 f95 mpif77 mpf77 mpxlf95"      #  look for possible FORTRAN compilers
367        tmp="$MITGCM_FC $FC efc g77 f77 pgf77 pgf95 ifc ifort f90 f95 mpif77 mpf77 mpxlf95 gfortran g95"
368      p_FC=      p_FC=
369      for c in $tmp ; do      for c in $tmp ; do
370          rm -f ./hello.f ./hello          rm -f ./hello.f ./hello
# Line 269  Error: No Fortran compilers were found i Line 389  Error: No Fortran compilers were found i
389    
390      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),      1) an "optfile" on (eg. "-optfile=path/to/OPTFILE"),
391      2) a command-line option (eg. "-fc NAME"), or      2) a command-line option (eg. "-fc NAME"), or
392      3) the MITGCM_FC environment variable.      3) the FC or MITGCM_FC environment variables.
393    
394  EOF  EOF
395          exit 1          exit 1
396      else      else
397          echo "  The possible FORTRAN compilers found in your path are:"          echo "  The possible FORTRAN compilers found in your path are:"
398          echo "   "$p_FC          echo "   "$p_FC
399          if test "x$FC" = x ; then      fi
400              FC=`echo $p_FC | $AWK '{print $1}'`  
401              echo "  Setting FORTRAN compiler to: "$FC      #  Use the first of the compilers found in the current PATH
402          fi      #  that has a correctly-named optfile
403        if test "x$OPTFILE" = x  -a  "x$FC" = x ; then
404            for i in $p_FC ; do
405                OPTFILE=$ROOTDIR"/tools/build_options/"$PLATFORM"_"$i
406                if test -r $OPTFILE ; then
407                    echo "  Setting OPTFILE to: "$OPTFILE
408                    break
409                fi
410            done
411      fi      fi
412    
413      if test "x$OPTFILE" = x ; then      if test "x$OPTFILE" = x ; then
# Line 440  Usage: "$0" [OPTIONS] Line 568  Usage: "$0" [OPTIONS]
568            will search for a working compiler by trying a list of            will search for a working compiler by trying a list of
569            "usual suspects" such as g77, f77, etc.            "usual suspects" such as g77, f77, etc.
570    
571        -cc NAME | --cc NAME | -cc=NAME | --cc=NAME
572              Use "NAME" as the C compiler.  By default, genmake
573              will search for a working compiler by trying a list of
574              "usual suspects" such as gcc, c89, cc, etc.
575    
576      -[no]ieee | --[no]ieee      -[no]ieee | --[no]ieee
577            Do or don't use IEEE numerics.  Note that this option            Do or don't use IEEE numerics.  Note that this option
578            *only* works if it is supported by the OPTFILE that            *only* works if it is supported by the OPTFILE that
579            is being used.            is being used.
580    
581        -ignoretime | -ignore_time | --ignoretime | --ignore_time
582              Ignore all the "wall clock" routines entirely.  This will
583              not in any way hurt the model results -- it simply means
584              that the code that checks how long the model spends in
585              various routines will give junk values.
586    
587        -ts | --ts
588              Produce timing information per timestep
589        -papis | --papis
590              Produce summary MFlop/s (and IPC) with PAPI per timestep
591        -pcls | --pcls
592              Produce summary MFlop/s etc. with PCL per timestep
593        -foolad | --foolad
594              Fool the AD code generator
595        -papi | --papi
596              Performance analysis with PAPI
597        -pcl | --pcl
598              Performance analysis with PCL
599        -hpmt | --hpmt
600              Performance analysis with the HPM Toolkit
601    
602        -gsl | --gsl
603              Use GSL to control floating point rounding and precision
604        -devel | --devel
605              Add additional warning and debugging flags for development
606    
607      -mpi | --mpi      -mpi | --mpi
608            Include MPI header files and link to MPI libraries            Include MPI header files and link to MPI libraries
609      -mpi=PATH | --mpi=PATH      -mpi=PATH | --mpi=PATH
610            Include MPI header files and link to MPI libraries using MPI_ROOT            Include MPI header files and link to MPI libraries using MPI_ROOT
611            set to PATH. i.e. Include files from $PATH/include, link to libraries            set to PATH. i.e. Include files from \$PATH/include, link to libraries
612            from $PATH/lib and use binaries from $PATH/bin.            from \$PATH/lib and use binaries from \$PATH/bin.
613    
614        -es | --es | -embed-source | --embed-source
615              Embed a tarball containing the full source code
616              (including the Makefile, etc.) used to build the
617              executable [off by default]
618    
619      -bash NAME      -bash NAME
620            Explicitly specify the Bourne or BASH shell to use            Explicitly specify the Bourne or BASH shell to use
# Line 475  EOF Line 639  EOF
639    
640  #  Build a CPP macro to automate calling C routines from FORTRAN  #  Build a CPP macro to automate calling C routines from FORTRAN
641  get_fortran_c_namemangling()  {  get_fortran_c_namemangling()  {
642    
643        #echo "FC_NAMEMANGLE = \"$FC_NAMEMANGLE\""
644        if test ! "x$FC_NAMEMANGLE" = x ; then
645            return 0
646        fi
647    
648      default_nm="#define FC_NAMEMANGLE(X) X ## _"      default_nm="#define FC_NAMEMANGLE(X) X ## _"
649            
650      cat > genmake_test.c <<EOF      cat > genmake_test.c <<EOF
# Line 492  WARNING: Please contact <MITgcm-support@ Line 662  WARNING: Please contact <MITgcm-support@
662  EOF  EOF
663          return 1          return 1
664      fi      fi
665      c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`      c_tcall=`nm genmake_test.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
666      RETVAL=$?      RETVAL=$?
667      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
668          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 504  WARNING: Please contact <MITgcm-support@ Line 674  WARNING: Please contact <MITgcm-support@
674  EOF  EOF
675          return 1          return 1
676      fi      fi
677      cat > genmake_tcomp.f <<EOF      cat > genmake_tcomp.$FS <<EOF
678        subroutine tcall( string )        subroutine tcall( string )
679        character*(*) string        character*(*) string
680        call tsub( string )        call tsub( string )
681        end        end
682  EOF  EOF
683      $FC $FFLAGS $DEFINES -c genmake_tcomp.f >> genmake_warnings 2>&1      $FC $FFLAGS -c genmake_tcomp.$FS >> genmake_warnings 2>&1
684      RETVAL=$?      RETVAL=$?
685      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
686          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 522  WARNING: Please contact <MITgcm-support@ Line 692  WARNING: Please contact <MITgcm-support@
692  EOF  EOF
693          return 1          return 1
694      fi      fi
695      f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`      f_tcall=`nm genmake_tcomp.o 2>/dev/null | grep 'T ' | grep tcall | cut -d ' ' -f 3`
696      RETVAL=$?      RETVAL=$?
697      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
698          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 576  void FC_NAMEMANGLE(cloc) ( double *curti Line 746  void FC_NAMEMANGLE(cloc) ( double *curti
746   *curtim = *curtim/1.E6;   *curtim = *curtim/1.E6;
747  }  }
748  EOF  EOF
749      make genmake_tc_1.o >> genmake_tc.log 2>&1      make genmake_tc_1.o >> genmake_warnings 2>&1
750      RET_C=$?      RET_C=$?
751      cat <<EOF > genmake_tc_2.f      cat <<EOF > genmake_tc_2.$FS
752        program hello        program hello
753        Real*8 wtime        REAL*8 wtime
754        external cloc        external cloc
755        call cloc(wtime)        call cloc(wtime)
756        print *," HELLO WORLD", wtime        print *," HELLO WORLD", wtime
757        end program hello        end
758  EOF  EOF
759      $FC $FFLAGS -o genmake_tc genmake_tc_2.f genmake_tc_1.o >> genmake_tc.log 2>&1      $FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o >> genmake_warnings 2>&1
760      RET_F=$?      RET_F=$?
761      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_tc.log 2>&1      test -x ./genmake_tc  &&  ./genmake_tc >> genmake_warnings 2>&1
762      RETVAL=$?      RETVAL=$?
763      if test "x$RETVAL" = x0 ; then      if test "x$RETVAL" = x0 ; then
764          HAVE_CLOC=t          HAVE_CLOC=t
# Line 598  EOF Line 768  EOF
768  }  }
769    
770    
771    check_HAVE_SIGREG()  {
772        if test ! "x$HAVE_SIGREG" = x ; then
773            return
774        fi
775        get_fortran_c_namemangling
776        cat <<EOF > genmake_tc_1.c
777    $FC_NAMEMANGLE
778    #include <stdlib.h>
779    #include <stdio.h>
780    #include <signal.h>
781    #include <errno.h>
782    #include <ucontext.h>
783    
784    int * ip;
785    
786    static void killhandler(
787        unsigned int sn, siginfo_t  si, struct ucontext *sc )
788    {
789        *ip = *ip + 1;
790        return;
791    }
792    
793    void FC_NAMEMANGLE(sigreg) (int * aip)
794    {
795        struct sigaction s;
796        ip = aip;
797        s.sa_flags = SA_SIGINFO;
798        s.sa_sigaction = (void *)killhandler;
799        if(sigaction (SIGTERM,&s,(struct sigaction *)NULL)) {
800            printf("Sigaction returned error = %d\n", errno);
801            exit(0);
802        }
803        return;
804    }
805    EOF
806        make genmake_tc_1.o >> genmake_warnings 2>&1
807        RET_C=$?
808        cat <<EOF > genmake_tc_2.$FS
809          program hello
810          integer anint
811          common /iv/ anint
812          external sigreg
813          call sigreg(anint)
814          end
815    EOF
816        echo >> genmake_warnings
817        echo "running: check_HAVE_SIGREG()" >> genmake_warnings
818        cat genmake_tc_2.$FS >> genmake_warnings
819        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
820        echo $COMM >> genmake_warnings
821        $COMM >> genmake_warnings 2>&1
822        RETVAL=$?
823        if test "x$RETVAL" = x0 ; then
824            HAVE_SIGREG=t
825            DEFINES="$DEFINES -DHAVE_SIGREG"
826        fi
827        rm -f genmake_tc*
828    }
829    
830    
831    check_HAVE_SETRLSTK()  {
832        if test "x$HAVE_SETRLSTK" = xt ; then
833            DEFINES="$DEFINES -DHAVE_SETRLSTK"
834            return
835        fi  
836        if test ! "x$HAVE_SETRLSTK" = x ; then
837            return
838        fi
839        get_fortran_c_namemangling
840        cat <<EOF > genmake_tc_1.c
841    $FC_NAMEMANGLE
842    #include <sys/time.h>
843    #include <sys/resource.h>
844    #include <unistd.h>
845    void FC_NAMEMANGLE(setrlstk) ()
846    {
847        struct rlimit rls;
848        rls.rlim_cur = RLIM_INFINITY;
849        rls.rlim_max = RLIM_INFINITY;
850        setrlimit(RLIMIT_STACK, &rls);
851        return;
852    }
853    EOF
854        make genmake_tc_1.o >> genmake_warnings 2>&1
855        RET_C=$?
856        cat <<EOF > genmake_tc_2.$FS
857          program hello
858          external setrlstk
859          call setrlstk()
860          end
861    EOF
862        echo >> genmake_warnings
863        echo "running: check_HAVE_SETRLSTK()" >> genmake_warnings
864        cat genmake_tc_2.$FS >> genmake_warnings
865        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
866        echo $COMM >> genmake_warnings
867        $COMM >> genmake_warnings 2>&1
868        RETVAL=$?
869        if test "x$RETVAL" = x0 ; then
870            HAVE_SETRLSTK=t
871            DEFINES="$DEFINES -DHAVE_SETRLSTK"
872        fi
873        rm -f genmake_tc*
874    }
875    
876    
877    check_HAVE_STAT()  {
878        get_fortran_c_namemangling
879        cat <<EOF > genmake_tc_1.c
880    $FC_NAMEMANGLE
881    #include <stdio.h>
882    #include <stdlib.h>
883    #include <unistd.h>
884    #include <sys/stat.h>
885    #include <sys/types.h>
886    void FC_NAMEMANGLE(tfsize) ( int *nbyte )
887    {
888        char name[512];
889        struct stat astat;
890    
891        name[0] = 'a'; name[1] = '\0';
892        if (! stat(name, &astat))
893            *nbyte = (int)(astat.st_size);
894        else
895            *nbyte = -1;
896    }
897    EOF
898        make genmake_tc_1.o >> genmake_tc.log 2>&1
899        RET_C=$?
900        cat <<EOF > genmake_tc_2.$FS
901          program hello
902          integer nbyte
903          call tfsize(nbyte)
904          print *," HELLO WORLD", nbyte
905          end
906    EOF
907        echo >> genmake_warnings
908        echo "running: check_HAVE_STAT()" >> genmake_warnings
909        cat genmake_tc_2.$FS >> genmake_warnings
910        COMM="$FC $FFLAGS -o genmake_tc genmake_tc_2.$FS genmake_tc_1.o"
911        echo $COMM >> genmake_warnings
912        $COMM >> genmake_tc.log 2>&1
913        RETVAL=$?
914        if test "x$RETVAL" = x0 ; then
915            HAVE_STAT=t
916            DEFINES="$DEFINES -DHAVE_STAT"
917        fi
918        rm -f genmake_tc*
919    }
920    
921    
922  check_netcdf_libs()  {  check_netcdf_libs()  {
923      cat <<EOF > genmake_tnc.for      if test ! "x$SKIP_NETCDF_CHECK" = x ; then
924            return
925        fi
926        echo >> genmake_warnings
927        echo "running: check_netcdf_libs()" >> genmake_warnings
928        cat <<EOF > genmake_tnc.F
929        program fgennc        program fgennc
930  #include "netcdf.inc"  #include "netcdf.inc"
931    EOF
932        if test ! "x$MPI" = x ; then
933            echo '#include "mpif.h"' >> genmake_tnc.F
934        fi
935        cat <<EOF >> genmake_tnc.F
936        integer iret, ncid, xid        integer iret, ncid, xid
937        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)        iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
938        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
# Line 611  check_netcdf_libs()  { Line 942  check_netcdf_libs()  {
942        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)        IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
943        end        end
944  EOF  EOF
945      $CPP genmake_tnc.for > genmake_tnc.f  \      echo "===  genmake_tnc.F  ===" > genmake_tnc.log
946          &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1      cat genmake_tnc.F >> genmake_tnc.log
947        echo "===  genmake_tnc.F  ===" >> genmake_tnc.log
948        RET_CPP=f
949        COMM="cat genmake_tnc.F | $CPP $DEFINES $INCLUDES"
950        echo "$COMM" >> genmake_tnc.log
951        eval $COMM > genmake_tnc.$FS 2>/dev/null  &&  RET_CPP=t
952        if test "x$RET_CPP" = xf ; then
953            echo "  WARNING: CPP failed to pre-process the netcdf test." \
954                >> genmake_tnc.log
955            echo "    Please check that \$INCLUDES is properly set." \
956                >> genmake_tnc.log
957        fi
958        echo "$FC $FFLAGS $FOPTIM -c genmake_tnc.$FS  \ " >> genmake_tnc.log
959        echo "  &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc.o $LIBS" >> genmake_tnc.log
960        $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
961            &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS >> genmake_tnc.log 2>&1
962      RET_COMPILE=$?      RET_COMPILE=$?
963      test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1      cat genmake_tnc.log >> genmake_warnings
964      RETVAL=$?  
965      if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then      #EH3  Remove test program execution for machines that either disallow
966        #EH3  execution or cannot support it (eg. cross-compilers)
967        #EH3
968        #EH3 test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
969        #EH3 RETVAL=$?
970        #EH3 if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
971    
972        if test "x$RET_COMPILE" = x0 ; then
973          HAVE_NETCDF=t          HAVE_NETCDF=t
974      else      else
975          # try again with "-lnetcdf" added to the libs          # try again with "-lnetcdf" added to the libs
976          $CPP genmake_tnc.for > genmake_tnc.f  \          echo "try again with added '-lnetcdf'" > genmake_tnc.log
977              &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \          echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
978              $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1          echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
979            echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
980            cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
981                &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
982                &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf >> genmake_tnc.log 2>&1
983          RET_COMPILE=$?          RET_COMPILE=$?
984          test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1          cat genmake_tnc.log >> genmake_warnings
985          RETVAL=$?          if test "x$RET_COMPILE" = x0 ; then
         if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then  
986              LIBS="$LIBS -lnetcdf"              LIBS="$LIBS -lnetcdf"
987              HAVE_NETCDF=t              HAVE_NETCDF=t
988          else          else
989            # try again with "-lnetcdff" added to the libs
990                echo "try again with added '-lnetcdff -lnetcdf'" > genmake_tnc.log
991                echo "cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS \ " >> genmake_tnc.log
992                echo " &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS \ " >> genmake_tnc.log
993                echo " &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdf" >> genmake_tnc.log
994                cat genmake_tnc.F | $CPP $DEFINES $INCLUDES > genmake_tnc.$FS 2>/dev/null  \
995                    &&  $FC $FFLAGS $FOPTIM -c genmake_tnc.$FS >> genmake_tnc.log 2>&1  \
996                    &&  $LINK $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.o $LIBS -lnetcdff -lnetcdf >> genmake_tnc.log 2>&1
997                RET_COMPILE=$?
998              cat genmake_tnc.log >> genmake_warnings              cat genmake_tnc.log >> genmake_warnings
999                if test "x$RET_COMPILE" = x0 ; then
1000                    LIBS="$LIBS -lnetcdff -lnetcdf"
1001                    HAVE_NETCDF=t
1002                fi
1003          fi          fi
1004      fi      fi
1005      rm -f genmake_tnc*      rm -f genmake_tnc*
# Line 649  PLATFORM= Line 1018  PLATFORM=
1018  LN=  LN=
1019  S64=  S64=
1020  KPP=  KPP=
1021  FC=  #FC=
1022  CPP=  #CC=gcc
1023    #CPP=
1024  LINK=  LINK=
1025  DEFINES=  DEFINES=
1026  PACKAGES=  PACKAGES=
1027  ENABLE=  ENABLE=
1028  DISABLE=  DISABLE=
1029  MAKEFILE=  # MAKEFILE=
1030  MAKEDEPEND=  # MAKEDEPEND=
1031  PDEPEND=  PDEPEND=
1032  DUMPSTATE=t  DUMPSTATE=t
1033  PDEFAULT=  PDEFAULT=
1034  OPTFILE=  OPTFILE=
1035  INCLUDES="-I."  INCLUDES="-I. $INCLUDES"
1036  FFLAGS=  FFLAGS=
1037  FOPTIM=  FOPTIM=
1038  CFLAGS=  CFLAGS=
# Line 675  NOOPTFILES= Line 1045  NOOPTFILES=
1045  NOOPTFLAGS=  NOOPTFLAGS=
1046  MPI=  MPI=
1047  MPIPATH=  MPIPATH=
1048    TS=
1049    PAPIS=
1050    PCLS=
1051    FOOLAD=
1052    PAPI=
1053    PCL=
1054    HPMT=
1055    GSL=
1056    DEVEL=
1057    HAVE_TEST_L=
1058    
1059  # DEFINES checked by test compilation  # DEFINES checked by test compilation or command-line
1060  HAVE_SYSTEM=  HAVE_SYSTEM=
1061  HAVE_FDATE=  HAVE_FDATE=
1062  FC_NAMEMANGLE=  FC_NAMEMANGLE=
1063  HAVE_CLOC=  HAVE_CLOC=
1064    # HAVE_SETRLSTK=
1065    HAVE_STAT=
1066  HAVE_NETCDF=  HAVE_NETCDF=
1067  HAVE_ETIME=  HAVE_ETIME=
1068    IGNORE_TIME=
1069    
1070  MODS=  MODS=
1071  TOOLSDIR=  TOOLSDIR=
# Line 693  STANDARDDIRS="USE_THE_DEFAULT" Line 1076  STANDARDDIRS="USE_THE_DEFAULT"
1076  G2ARGS=  G2ARGS=
1077  BASH=  BASH=
1078  PWD=`pwd`  PWD=`pwd`
1079  MAKE=make  test "x$MAKE" = x  &&  MAKE=make
1080  AWK=awk  test "x$AWK" = x   &&  AWK=awk
1081  THISHOSTNAME=`hostname`  EMBED_SRC=
1082    THISHOST=`hostname`
1083  THISCWD=`pwd`  THISCWD=`pwd`
1084  THISDATE=`date`  THISDATE=`date`
1085    THISUSER=`echo $USER`
1086    THISVER=
1087  MACHINE=`uname -a`  MACHINE=`uname -a`
1088  EXECUTABLE=  EXECUTABLE=
1089  EXEHOOK=  EXEHOOK=
# Line 726  TAMC_EXTRA= Line 1112  TAMC_EXTRA=
1112    
1113  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
1114  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
1115  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE TS PAPIS PCLS PAPI PCL HPMT GSL DEVEL MPI JAM DUMPSTATE STANDARDDIRS"
1116    
1117  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
1118  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
1119  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"  gm_s4="CFLAGS KFLAGS1 KFLAGS2 LIBS KPPFILES NOOPTFILES NOOPTFLAGS"
1120  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOSTNAME THISDATE MACHINE"  gm_s5="TOOLSDIR SOURCEDIRS INCLUDEDIRS PWD MAKE THISHOST THISUSER THISDATE THISVER MACHINE"
1121  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"  gm_s6="EXECUTABLE EXEHOOK EXEDIR PACKAGES_CONF"
1122  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"  gm_s7="HAVE_SYSTEM HAVE_FDATE FC_NAMEMANGLE HAVE_ETIME"
1123    
# Line 763  for i in . $MODS ; do Line 1149  for i in . $MODS ; do
1149      fi      fi
1150  done  done
1151  printf "  getting local config information:  "  printf "  getting local config information:  "
1152  if test -e $gm_local ; then  if test -f $gm_local ; then
1153      echo "using $gm_local"      echo "using $gm_local"
1154      . $gm_local      . $gm_local
1155      # echo "DISABLE=$DISABLE"      # echo "DISABLE=$DISABLE"
# Line 772  else Line 1158  else
1158      echo "none found"      echo "none found"
1159  fi  fi
1160    
1161  #  echo "$0::$1:$2:$3:$4:$5:$6:$7:"  #echo "$0::$1:$2:$3:$4:$5:$6:$7:"
1162  #OPTIONS=  #OPTIONS=
1163  #n=0  #n=0
1164  #for i ; do  #for i ; do
# Line 784  fi Line 1170  fi
1170  #done  #done
1171  #parse_options  #parse_options
1172  ac_prev=  ac_prev=
1173  for ac_option ; do  for ac_option in "$@" ; do
1174    
1175      G2ARGS="$G2ARGS \"$ac_option\""      G2ARGS="$G2ARGS \"$ac_option\""
1176    
# Line 880  for ac_option ; do Line 1266  for ac_option ; do
1266  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
1267  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
1268  #               CPP=$ac_optarg ;;  #               CPP=$ac_optarg ;;
1269                        
1270            -cc | --cc)
1271                ac_prev=CC ;;
1272            -cc=* | --cc=*)
1273                CC=$ac_optarg ;;
1274            
1275          -fortran | --fortran | -fc | --fc)          -fortran | --fortran | -fc | --fc)
1276              ac_prev=FC ;;              ac_prev=FC ;;
1277          -fc=* | --fc=*)          -fc=* | --fc=*)
# Line 901  for ac_option ; do Line 1292  for ac_option ; do
1292          -noieee | --noieee)          -noieee | --noieee)
1293              IEEE= ;;              IEEE= ;;
1294    
1295            -ts | --ts)
1296                TS=true ;;
1297            -papis | --papis)
1298                PAPIS=true ;;
1299            -pcls | --pcls)
1300                PCLS=true ;;
1301            -foolad | --foolad)
1302                FOOLAD=true ;;
1303            -papi | --papi)
1304                PAPI=true ;;
1305            -pcl | --pcl)
1306                PCL=true ;;
1307            -hpmt | --hpmt)
1308                HPMT=true ;;
1309    
1310            -gsl | --gsl)
1311                GSL=true ;;
1312    
1313            -devel | --devel)
1314                DEVEL=true ;;
1315    
1316          -mpi | --mpi)          -mpi | --mpi)
1317              MPI=true ;;              MPI=true ;;
1318          -mpi=* | --mpi=*)          -mpi=* | --mpi=*)
# Line 924  for ac_option ; do Line 1336  for ac_option ; do
1336              ac_prev=TAMC_EXTRA ;;              ac_prev=TAMC_EXTRA ;;
1337          -tamc_extra=* | --tamc_extra=*)          -tamc_extra=* | --tamc_extra=*)
1338              TAMC_EXTRA=$ac_optarg ;;              TAMC_EXTRA=$ac_optarg ;;
1339            
1340            -ignoretime | -ignore_time | --ignoretime | --ignore_time)
1341                IGNORE_TIME="-DIGNORE_TIME" ;;
1342    
1343            -es | --es | -embed-source | --embed-source)
1344                EMBED_SRC=t ;;
1345    
1346          -*)          -*)
1347              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
# Line 939  for ac_option ; do Line 1357  for ac_option ; do
1357            
1358  done  done
1359    
1360    
1361  if test -f ./.genmakerc ; then  if test -f ./.genmakerc ; then
1362      echo      echo
1363      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""      echo "WARNING: genmake2 has detected a copy of the old-style \"./.genmakerc\""
1364      echo "  file.  This file format is no longer supported.  Please see:"      echo "  file.  This file format is no longer supported.  For directions on"
1365      echo      echo "  how to setup and use the new \"genmake2\" script, please see:"
1366      echo "    http://mitgcm.org/devel_HOWTO/"      echo "    http://mitgcm.org/devel_HOWTO/"
1367      echo      echo "  and send an email to MITgcm-support@mitgcm.org if you need help."
1368      echo "  for directions on how to setup and use the new \"genmake2\" input"      echo "WARNING: ignore \"./.genmakerc\" and continue."
     echo "  files and send an email to MITgcm-support@mitgcm.org if you want help."  
1369      echo      echo
1370  fi  fi
1371    
1372    #  Find the MITgcm ${ROOTDIR}
1373  if test "x${ROOTDIR}" = x ; then  if test "x${ROOTDIR}" = x ; then
1374      if test "${PWD##/*/}" = "bin" -a -d ../model -a -d ../eesup -a -d ../pkg ; then      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1375        if test "x$tmp" = "xbin" -a -d ../model -a -d ../eesupp -a -d ../pkg ; then
1376          ROOTDIR=".."          ROOTDIR=".."
1377      else      else
1378          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do          for d in . .. ../.. ../../.. ../../../.. ../../../../.. ; do
# Line 976  if test ! -d ${ROOTDIR} ; then Line 1396  if test ! -d ${ROOTDIR} ; then
1396      exit 1      exit 1
1397  fi  fi
1398    
1399    #  Find the MITgcm ${THISVER}
1400    if test -f "${ROOTDIR}/doc/tag-index" ; then
1401        THISVER=`grep '^checkpoint' ${ROOTDIR}/doc/tag-index | head -1`
1402    fi
1403    
1404    if test "x$MAKEFILE" = x ; then
1405        MAKEFILE="Makefile"
1406    fi
1407    
1408  echo "  getting OPTFILE information:  "  echo "  getting OPTFILE information:  "
1409  if test "x${OPTFILE}" = x ; then  if test "x${OPTFILE}" = x ; then
1410      if test "x$MITGCM_OF" = x ; then      if test "x$MITGCM_OF" = x ; then
# Line 1005  if test "x$OPTFILE" != xNONE ; then Line 1434  if test "x$OPTFILE" != xNONE ; then
1434      fi      fi
1435  fi  fi
1436    
 #  Check for broken systems that cannot correctly distinguish *.F and *.f files  
 # check_for_broken_Ff  
   
1437  echo "  getting AD_OPTFILE information:  "  echo "  getting AD_OPTFILE information:  "
1438  if test "x${AD_OPTFILE}" = x ; then  if test "x${AD_OPTFILE}" = x ; then
1439      if test "x$MITGCM_AD_OF" = x ; then      if test "x$MITGCM_AD_OF" = x ; then
# Line 1035  if test "x${AD_OPTFILE}" != xNONE ; then Line 1461  if test "x${AD_OPTFILE}" != xNONE ; then
1461      fi      fi
1462  fi  fi
1463    
1464  #  Check that FC, LINK, CPP, S64, LN, and MAKE are defined.  If not,  #====================================================================
1465    #  Set default values if not set by the optfile
1466    #
1467    #  Check that FC, CC, LINK, CPP, S64, LN, and MAKE are defined.  If not,
1468  #  either set defaults or complain and abort!  #  either set defaults or complain and abort!
1469  if test ! "x$BASH" = x ; then  if test ! "x$BASH" = x ; then
1470      # add a trailing space so that it works within the Makefile syntax (see below)      # add a trailing space so that it works within the Makefile syntax (see below)
# Line 1051  Error: no Fortran compiler: please speci Line 1480  Error: no Fortran compiler: please speci
1480  EOF  EOF
1481      exit 1      exit 1
1482  fi  fi
1483    if test "x$CC" = x ; then
1484        CC=cc
1485    #     cat <<EOF 1>&2
1486    # Error: no C compiler: please specify using one of the following:
1487    #   1) within the options file ("CC=...") as specified by "-of=OPTFILE"
1488    #   2) the "-cc=XXX" command-line option
1489    #   3) the "./genmake_local" file
1490    # EOF
1491    #     exit 1
1492    fi
1493  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
1494      LINK=$FC      LINK=$FC
1495  fi  fi
# Line 1085  EOF Line 1524  EOF
1524  else  else
1525      rm -f test_cpp      rm -f test_cpp
1526  fi  fi
1527  if test "x$MAKEDEPEND" = x ; then  look_for_makedepend
     MAKEDEPEND=makedepend  
 fi  
1528  if test "x$LN" = x ; then  if test "x$LN" = x ; then
1529      LN="ln -s"      LN="ln -s"
1530  fi  fi
# Line 1103  Error: The command "ln -s" failed -- ple Line 1540  Error: The command "ln -s" failed -- ple
1540  EOF  EOF
1541      exit 1      exit 1
1542  fi  fi
1543    test -L genmake_tlink > /dev/null 2>&1
1544    RETVAL=$?
1545    if test "x$RETVAL" = x0 ; then
1546        HAVE_TEST_L=t
1547    fi
1548  rm -f genmake_test_ln genmake_tlink  rm -f genmake_test_ln genmake_tlink
1549    
1550  #  Check for broken *.F/*.f handling and fix if possible  #  Check for broken *.F/*.f handling and fix if possible
# Line 1113  if test ! "x$MPI" = x ; then Line 1555  if test ! "x$MPI" = x ; then
1555        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"        DEFINES="$DEFINES -DALLOW_USE_MPI -DALWAYS_USE_MPI"
1556  fi  fi
1557    
1558    if test ! "x$TS" = x ; then
1559          echo "  Turning on timing per timestep"
1560          if test ! "x$FOOLAD" = x ; then
1561                DEFINES="$DEFINES -DTIME_PER_TIMESTEP_SFP"
1562          else
1563                DEFINES="$DEFINES -DTIME_PER_TIMESTEP"
1564          fi
1565    fi
1566    if test ! "x$PAPIS" = x ; then
1567          echo "  Turning on PAPI flop summary per timestep"
1568          echo "  Please make sure PAPIINC, PAPILIB are defined"
1569          if test ! "x$FOOLAD" = x ; then
1570                DEFINES="$DEFINES -DUSE_PAPI_FLOPS_SFP"
1571          else
1572                DEFINES="$DEFINES -DUSE_PAPI_FLOPS"
1573          fi
1574          INCLUDES="$INCLUDES $PAPIINC"
1575          LIBS="$LIBS $PAPILIB"
1576    fi
1577    if test ! "x$PCLS" = x ; then
1578          echo "  Turning on PCL counter summary per timestep"
1579          echo "  Please make sure PCLINC, PCLLIB are defined"
1580          if test ! "x$FOOLAD" = x ; then
1581                DEFINES="$DEFINES -DUSE_PCL_FLOPS_SFP"
1582          else
1583                DEFINES="$DEFINES -DUSE_PCL_FLOPS"
1584          fi
1585          INCLUDES="$INCLUDES $PCLINC"
1586          LIBS="$LIBS $PCLLIB"
1587    fi
1588    if test ! "x$PAPI" = x ; then
1589          if test ! "x$PAPIS" = x ; then
1590              echo "  PAPI performance analysis and flop summary per timestep cannot co-exist!"
1591              echo "  Sticking with PAPI flop summary per timestep!"
1592          else
1593              echo "  Turning on performance analysis with PAPI"
1594              echo "  Please make sure PAPIINC, PAPILIB are defined"
1595              DEFINES="$DEFINES -DUSE_PAPI"
1596              INCLUDES="$INCLUDES $PAPIINC"
1597              LIBS="$LIBS $PAPILIB"
1598          fi
1599    fi
1600    if test ! "x$PCL" = x ; then
1601          if test ! "x$PCLS" = x ; then
1602              echo "  PCL performance analysis and flop summary per timestep cannot co-exist!"
1603              echo "  Sticking with PCL flop summary per timestep!"
1604          else
1605              echo "  Turning on performance analysis with PCL"
1606              echo "  Please make sure PCLINC, PCLLIB are defined"
1607              DEFINES="$DEFINES -DUSE_PCL"
1608              INCLUDES="$INCLUDES $PCLINC"
1609              LIBS="$LIBS $PCLLIB"
1610          fi
1611    fi
1612    if test ! "x$HPMT" = x ; then
1613          if test ! "x$PAPI" = x ; then
1614              echo "  PAPI and the HPM Toolkit cannot co-exist!"
1615              echo "  Sticking with PAPI!"
1616          else if test ! "x$PCL" = x ; then
1617              echo "  PCL and the HPM Toolkit cannot co-exist!"
1618              echo "  Sticking with PCL!"
1619          else
1620              echo "  Turning on performance analysis with the HPM Toolkit"
1621              echo "  Please make sure HPMTINC, HPMTLIB are defined"
1622              DEFINES="$DEFINES -DUSE_LIBHPM"
1623              INCLUDES="$INCLUDES $HPMTINC"
1624              LIBS="$LIBS $HPMTLIB"
1625          fi
1626          fi
1627    fi
1628    if test ! "x$GSL" = x ; then
1629          echo "  Turning on use of GSL to control floating point calculations"
1630          echo "  Please make sure GSLINC, GSLLIB are defined"
1631          DEFINES="$DEFINES -DUSE_GSL_IEEE"
1632          INCLUDES="$INCLUDES $GSLINC"
1633          LIBS="$LIBS $GSLLIB"
1634    fi
1635    
1636  printf "\n===  Checking system libraries  ===\n"  printf "\n===  Checking system libraries  ===\n"
1637  printf "  Do we have the system() command using $FC...  "  printf "  Do we have the system() command using $FC...  "
1638  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1639        program hello        program hello
1640        call system('echo hi')        call system('echo hi')
1641        end        end
1642  EOF  EOF
1643  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1644  RETVAL=$?  RETVAL=$?
1645  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1646      HAVE_SYSTEM=t      HAVE_SYSTEM=t
# Line 1133  fi Line 1653  fi
1653  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1654    
1655  printf "  Do we have the fdate() command using $FC...  "  printf "  Do we have the fdate() command using $FC...  "
1656  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1657        program hello        program hello
1658        CHARACTER(128) string        CHARACTER*(128) string
1659        string = ' '        string = ' '
1660        call fdate( string )        call fdate( string )
1661        print *, string        print *, string
1662        end        end
1663  EOF  EOF
1664  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1665  RETVAL=$?  RETVAL=$?
1666  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1667      HAVE_FDATE=t      HAVE_FDATE=t
# Line 1154  fi Line 1674  fi
1674  rm -f genmake_tcomp*  rm -f genmake_tcomp*
1675    
1676  printf "  Do we have the etime() command using $FC...  "  printf "  Do we have the etime() command using $FC...  "
1677  cat > genmake_tcomp.f <<EOF  cat > genmake_tcomp.$FS <<EOF
1678        program hello        program hello
1679        REAL*4 ACTUAL, TARRAY(2)        REAL*4 ACTUAL, TARRAY(2)
1680        EXTERNAL ETIME        EXTERNAL ETIME
# Line 1163  cat > genmake_tcomp.f <<EOF Line 1683  cat > genmake_tcomp.f <<EOF
1683        print *, tarray        print *, tarray
1684        end        end
1685  EOF  EOF
1686  $FC $FFLAGS $DEFINES -o genmake_tcomp genmake_tcomp.f > genmake_tcomp.log 2>&1  $FC $FFLAGS -o genmake_tcomp genmake_tcomp.$FS > genmake_tcomp.log 2>&1
1687  RETVAL=$?  RETVAL=$?
1688  if test "x$RETVAL" = x0 ; then  if test "x$RETVAL" = x0 ; then
1689      HAVE_ETIME=t      HAVE_ETIME=t
# Line 1181  if test "x$HAVE_CLOC" != x ; then Line 1701  if test "x$HAVE_CLOC" != x ; then
1701      echo "yes"      echo "yes"
1702  else  else
1703      echo "no"      echo "no"
1704        if test "x$EMBED_SRC" = xt ; then
1705            echo "    WARNING: you requested file embedding but it has"
1706            echo "      been disabled since C code cannot be called"
1707            EMBED_SRC=
1708        fi
1709    fi
1710    rm -f genmake_t*
1711    
1712    printf "  Can we unlimit the stack size using $FC...  "
1713    check_HAVE_SETRLSTK
1714    if test "x$HAVE_SETRLSTK" = xt ; then
1715        echo "yes"
1716    else
1717        echo "no"
1718    fi
1719    rm -f genmake_t*
1720    
1721    printf "  Can we register a signal handler using $FC...  "
1722    check_HAVE_SIGREG
1723    if test "x$HAVE_SIGREG" = xt ; then
1724        echo "yes"
1725    else
1726        echo "no"
1727    fi
1728    rm -f genmake_t*
1729    
1730    printf "  Can we use stat() through C calls...  "
1731    check_HAVE_STAT
1732    if test "x$HAVE_STAT" != x ; then
1733        echo "yes"
1734    else
1735        echo "no"
1736  fi  fi
1737  rm -f genmake_t*  rm -f genmake_t*
1738    
# Line 1191  if test "x$HAVE_NETCDF" != x ; then Line 1743  if test "x$HAVE_NETCDF" != x ; then
1743  else  else
1744      echo "no"      echo "no"
1745  fi  fi
1746    DEFINES="$DEFINES $IGNORE_TIME"
1747    
1748    if test "x$EMBED_SRC" = xt ; then
1749        build_embed_encode
1750    fi
1751    if test "x$EMBED_SRC" = xt ; then
1752        ENABLE="$ENABLE embed_files"
1753    fi
1754    
1755    
1756  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
# Line 1208  for d in $MODS ; do Line 1768  for d in $MODS ; do
1768  done  done
1769  echo  echo
1770    
 if test "x$MAKEFILE" = x ; then  
     MAKEFILE="Makefile"  
 fi  
1771  if test "x${PLATFORM}" = x ; then  if test "x${PLATFORM}" = x ; then
1772      PLATFORM=$p_PLATFORM      PLATFORM=$p_PLATFORM
1773  fi  fi
1774    
1775  if test "x${EXEDIR}" = x ; then  if test "x${EXEDIR}" = x ; then
1776      if test "${PWD##/*/}" = "bin" -a -d ../exe -a $ROOTDIR = .. ; then      tmp=`echo $PWD | sed -e 's/\// /g' | $AWK '{print $NR}'`
1777        if test "x$tmp" = "xbin" -a -d ../exe -a $ROOTDIR = .. ; then
1778          EXEDIR=../exe          EXEDIR=../exe
1779      else      else
1780          EXEDIR=.          EXEDIR=.
# Line 1235  if test ! -d ${TOOLSDIR} ; then Line 1793  if test ! -d ${TOOLSDIR} ; then
1793      exit 1      exit 1
1794  fi  fi
1795  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1796      S64='$(TOOLSDIR)/set64bitConst.sh'      echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.sh > /dev/null 2>&1
1797        RETVAL=$?
1798        if test "x${RETVAL}" = x0 ; then
1799            S64='$(TOOLSDIR)/set64bitConst.sh'
1800        else
1801            echo "3.0 _d 3" | ${TOOLSDIR}/set64bitConst.csh > /dev/null 2>&1
1802            RETVAL=$?
1803            if test "x${RETVAL}" = x0 ; then
1804                S64='$(TOOLSDIR)/set64bitConst.csh'
1805            else
1806                cat <<EOF
1807    
1808    ERROR: neither of the two default scripts:
1809    
1810        ${TOOLSDIR}/set64bitConst.sh
1811        ${TOOLSDIR}/set64bitConst.csh
1812    
1813      are working so please check paths or specify (with \$S64) a
1814      working version of this script.
1815    
1816    EOF
1817                exit 1
1818            fi
1819        fi
1820  fi  fi
1821  THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`  THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1822    
# Line 1257  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1838  if test -r $ROOTDIR"/eesupp/src/Makefile
1838      fi      fi
1839  fi  fi
1840    
1841  #same for exch2  #same for pkg/exch2 and pkg/regrid
1842  if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then  for pdir in exch2 regrid ; do
1843      echo "  Making source files in exch2 from  templates"      if test -r $ROOTDIR"/pkg/${pdir}/Makefile" ; then
1844      ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1          echo "  Making source files in pkg/${pdir} from templates"
1845      RETVAL=$?          ( cd $ROOTDIR"/pkg/"${pdir} && $MAKE ) > make_${pdir}.errors 2>&1
1846      if test "x${RETVAL}" = x0 ; then          RETVAL=$?
1847          rm -f make_exch2.errors          if test "x${RETVAL}" = x0 ; then
1848      else              rm -f make_${pdir}.errors
1849          echo "Error: problem encountered while building source files in exch2:"          else
1850          cat make_exch2.errors 1>&2              echo "Error: problem encountered while building source files in pkg/${pdir}:"
1851          exit 1              cat make_${pdir}.errors 1>&2
1852                exit 1
1853            fi
1854      fi      fi
1855  fi  done
1856    
1857  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1858  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
# Line 1334  else Line 1917  else
1917              PACKAGES="$PACKAGES $i"              PACKAGES="$PACKAGES $i"
1918          done          done
1919          echo "    before group expansion packages are: $PACKAGES"          echo "    before group expansion packages are: $PACKAGES"
1920          while ! expand_pkg_groups; do echo > /dev/null; done          RET=1
1921            while test $RET = 1 ; do expand_pkg_groups; RET=$?; done
1922          echo "    after group expansion packages are:  $PACKAGES"          echo "    after group expansion packages are:  $PACKAGES"
1923      fi      fi
1924  fi  fi
# Line 1379  done Line 1963  done
1963  rm -f ./.tmp_pack  rm -f ./.tmp_pack
1964  echo "    packages are:  $PACKAGES"  echo "    packages are:  $PACKAGES"
1965    
1966    #  Check for package MNC: if NetCDF is available, then build the MNC
1967    #  template files ; otherwise, delete mnc from the list of packages.
1968    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1969    RETVAL=$?
1970    if test "x$RETVAL" = x0 ; then
1971        if test "x$HAVE_NETCDF" != xt ; then
1972            cat <<EOF
1973    
1974    *********************************************************************
1975    WARNING: the "mnc" package was enabled but tests failed to compile
1976      NetCDF applications.  Please check that:
1977    
1978      1) NetCDF is correctly installed for this compiler and
1979      2) the LIBS variable (within the "optfile") specifies the correct
1980           NetCDF library to link against.
1981    
1982      Due to this failure, the "mnc" package is now DISABLED.
1983    *********************************************************************
1984    
1985    EOF
1986            PACKAGES=`echo $PACKAGES | sed -e 's/mnc//g'`
1987            DISABLE="$DISABLE mnc"
1988        else
1989            ( cd $ROOTDIR"/pkg/mnc" && $MAKE testclean && $MAKE templates ) > make_mnc.errors 2>&1
1990            RETVAL=$?
1991            if test "x${RETVAL}" = x0 ; then
1992                rm -f make_mnc.errors
1993            else
1994                echo "Error: problem encountered while building source files in pkg/mnc:"
1995                cat make_mnc.errors 1>&2
1996                exit 1
1997            fi
1998        fi
1999    fi
2000    
2001    #  Check for package PROFILES: if NetCDF is not available,
2002    #  then delete profiles from the list of available packages.
2003    echo $PACKAGES | grep ' profiles ' > /dev/null 2>&1
2004    RETVAL=$?
2005    if test "x$RETVAL" = x0 ; then
2006        if test "x$HAVE_NETCDF" != xt ; then
2007            cat <<EOF
2008    
2009    *********************************************************************
2010    WARNING: the "profiles" package was enabled but tests failed to
2011      compile NetCDF applications.  Please check that:
2012    
2013      1) NetCDF is correctly installed for this compiler and
2014      2) the LIBS variable (within the "optfile") specifies the correct
2015           NetCDF library to link against.
2016    
2017      Due to this failure, the "profiles" package is now DISABLED.
2018    *********************************************************************
2019    
2020    EOF
2021            PACKAGES=`echo $PACKAGES | sed -e 's/profiles//g'`
2022            DISABLE="$DISABLE profiles"
2023        fi
2024    fi
2025    
2026  echo "  applying package dependency rules"  echo "  applying package dependency rules"
2027  ck=  ck=
2028  while test "x$ck" != xtt ; do  while test "x$ck" != xtt ; do
2029      i=0      i=0
2030      # rtot=${#PNAME[@]}      # rtot=${#PNAME[@]}
2031      rtot=$nname      rtot=$nname
2032      while test $i -lt $rtot ; do      while test $i -le $rtot ; do
2033    
2034          #  Is $pname in the current $PACKAGES list?          #  Is $pname in the current $PACKAGES list?
2035          #  pname=${PNAME[$i]}          #  pname=${PNAME[$i]}
# Line 1419  while test "x$ck" != xtt ; do Line 2063  while test "x$ck" != xtt ; do
2063    
2064          #  Do we need to add $dname according to the dependency rules?          #  Do we need to add $dname according to the dependency rules?
2065          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then          if test "x$pin" = xt -a "x$plus" = "x+" -a "x$din" = xf ; then
2066                #echo "   " $pname ": need to add :" $dname
2067              in_dis="f"              in_dis="f"
2068              for dis in $DISABLE ; do              for dis in $DISABLE ; do
2069                  if test "x$dis" = "x$dname" ; then                  if test "x$dis" = "x$dname" ; then
# Line 1443  while test "x$ck" != xtt ; do Line 2088  while test "x$ck" != xtt ; do
2088              echo "  the dependency rules for \"$dname\""              echo "  the dependency rules for \"$dname\""
2089              exit 1              exit 1
2090          fi          fi
2091          i=$(( $i + 1 ))          i=`echo "$i + 1" | bc -l`
2092            #i=$(( $i + 1 ))
2093      done      done
2094      ck=$ck"t"      ck=$ck"t"
2095  done  done
# Line 1462  for i in $PACKAGES ; do Line 2108  for i in $PACKAGES ; do
2108      fi      fi
2109  done  done
2110    
 #  Build MNC templates and check for ability to build and use NetCDF  
 echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" = x0 ; then  
     ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1  
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         rm -f make_mnc.errors  
     else  
         echo "Error: problem encountered while building source files in pkg/mnc:"  
         cat make_mnc.errors 1>&2  
         exit 1  
     fi  
     if test "x$HAVE_NETCDF" != xt ; then  
         cat <<EOF  
   
 WARNING: the "mnc" package has been enabled but tests failed to  
   compile and/or execute NetCDF applications.  Please check that:  
   
   1) NetCDF is installed for your compiler and  
   2) the LIBS variable (within the 'optfile") specifies the correct  
        NetCDF library to link against.  
     
 EOF  
     fi  
 fi  
   
2111  # Create a list of #define and #undef to enable/disable packages  # Create a list of #define and #undef to enable/disable packages
2112  PACKAGES_DOT_H=PACKAGES_CONFIG.h  PACKAGES_DOT_H=PACKAGES_CONFIG.h
2113  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
# Line 1508  for n in $names ; do Line 2127  for n in $names ; do
2127              fi              fi
2128          done          done
2129          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
2130              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2131              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
2132          fi          fi
2133      fi      fi
2134  done  done
2135  ENABLED_PACKAGES=  ENABLED_PACKAGES=
2136  for i in $PACKAGES ; do  for i in $PACKAGES ; do
2137      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | sed -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
2138      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
2139  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
2140    
# Line 1599  for i in $SOURCEDIRS ; do Line 2218  for i in $SOURCEDIRS ; do
2218          cat $i/$j >> ad_files          cat $i/$j >> ad_files
2219      done      done
2220  done  done
2221    if test ! "x"$FS = "x.f" ; then
2222        cat ad_files | sed -e "s/\.f/.$FS/g" > ad_files_f
2223        mv -f ad_files_f ad_files
2224    fi
2225    
2226  echo  echo
2227  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
2228  echo "  setting INCLUDES"  echo "  setting INCLUDES"
2229  for i in $INCLUDEDIRS ; do  for i in $INCLUDEDIRS ; do
2230      if ! test -d $i ; then      if test ! -d $i ; then
 #       INCLUDES="$INCLUDES -I$i"  
 #   else  
2231          echo "Warning: can't find INCLUDEDIRS=\"$i\""          echo "Warning: can't find INCLUDEDIRS=\"$i\""
2232      fi      fi
2233  done  done
2234    
2235    if test ! "x$DIVA" = x ; then
2236        echo "  Creating the pseudo-MPI include directory"
2237        INCLUDES="-I./mpi_headers $INCLUDES"
2238        rm -rf ./mpi_headers
2239        mkdir -p ./mpi_headers
2240    
2241        if test "x$MPIINCLUDEDIR" = x ; then
2242            if test "x$MPIHOME" = x ; then
2243                MPIHOME='/usr'
2244            fi
2245            MPIINCLUDEDIR='$MPIHOME/include'
2246        fi
2247        
2248        if test -r $MPIINCLUDEDIR/mpif.h ; then
2249            for i in $MPI_HEADER_FILES; do
2250                cp -p $MPIINCLUDEDIR/$i ./mpi_headers
2251            done
2252    
2253            perl -i -pe 's/MPI_DISPLACEMENT_CURRENT=-1_8/MPI_DISPLACEMENT_CURRENT=-1/g' mpi_headers/mpif.h
2254        else
2255            echo " We cannot create a copy of mpif.h!"
2256    #       exit -1
2257        fi
2258    fi
2259    
2260  echo "  Determining the list of source and include files"  echo "  Determining the list of source and include files"
2261  rm -rf .links.tmp  rm -rf .links.tmp
2262  mkdir .links.tmp  mkdir .links.tmp
2263    touch .links.tmp/foo
2264    if test ! -r ".links.tmp/foo" ; then
2265        echo
2266        echo "ERROR : something is wrong with your directory permissions or"
2267        echo "   your user file-creation mask (\"umask\") since creating a"
2268        echo "   sub-dir, touch-ing a file within it, and then reading it is"
2269        echo "   not working.  Please try setting your umask to something"
2270        echo "   sane such as:"
2271        echo
2272        echo "      umask 0002"
2273        echo
2274        echo "   and please verify that you have the proper permissions for"
2275        echo "   creating sub-directories and then reading files created"
2276        echo "   within them."
2277        echo
2278        exit 1
2279    fi
2280    rm -f .links.tmp/foo
2281  echo "# This section creates symbolic links" > srclinks.tmp  echo "# This section creates symbolic links" > srclinks.tmp
2282  echo "" >> srclinks.tmp  echo "" >> srclinks.tmp
2283  printf 'SRCFILES = '    > srclist.inc  printf 'SRCFILES = '    > srclist.inc
# Line 1630  for d in $alldirs ; do Line 2293  for d in $alldirs ; do
2293      for sf in $sfiles ; do      for sf in $sfiles ; do
2294          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
2295              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
2296                    ignore_f=f
2297                  case $d/$sf in                  case $d/$sf in
2298                    ./$PACKAGES_DOT_H)                    ./$PACKAGES_DOT_H)
2299                            ignore_f=t
2300                          ;;                          ;;
2301                    ./AD_CONFIG.h)                    ./AD_CONFIG.h)
2302                            ignore_f=t
2303                          ;;                          ;;
2304                    ./FC_NAMEMANGLE.h)                    ./FC_NAMEMANGLE.h)
2305                            ignore_f=t
2306                          ;;                          ;;
2307                    *)                    ./BUILD_INFO.h)
2308                          touch .links.tmp/$sf                          ignore_f=t
                         deplist="$deplist $sf"  
                         ;;  
                 esac  
                 extn=`echo $sf | $AWK -F '.' '{print $NF}'`  
                 case $extn in  
                     F)  
                         echo    " \\"  >> srclist.inc  
                         printf " $sf" >> srclist.inc  
                         ;;  
                     F90)  
                         echo    " \\"  >> f90srclist.inc  
                         printf " $sf" >> f90srclist.inc  
                         ;;  
                     c)  
                         echo    " \\"  >> csrclist.inc  
                         printf " $sf" >> csrclist.inc  
2309                          ;;                          ;;
2310                      h)                    ./EMBEDDED_FILES.h)
2311                          echo    " \\"  >> hlist.inc                          ignore_f=t
                         printf " $sf" >> hlist.inc  
2312                          ;;                          ;;
2313                      flow)                    *)
2314                          echo    " \\"  >> ad_flow_files.inc                          #  For the local directory *ONLY*,
2315                          printf " $sf" >> ad_flow_files.inc                          #  ignore all soft-links
2316                            if test "x$HAVE_TEST_L" = xt -a "x$d" = x. -a -L $sf ; then
2317                                ignore_f=t
2318                            else
2319                                touch .links.tmp/$sf
2320                                deplist="$deplist $sf"
2321                            fi
2322                          ;;                          ;;
2323                  esac                  esac
2324                    if test "x$ignore_f" = xf ; then
2325                        extn=`echo $sf | $AWK -F. '{print $NF}'`
2326                        case $extn in
2327                            F)
2328                                echo    " \\"  >> srclist.inc
2329                                printf " $sf" >> srclist.inc
2330                                ;;
2331                            F90)
2332                                echo    " \\"  >> f90srclist.inc
2333                                printf " $sf" >> f90srclist.inc
2334                                ;;
2335                            c)
2336                                echo    " \\"  >> csrclist.inc
2337                                printf " $sf" >> csrclist.inc
2338                                ;;
2339                            h)
2340                                echo    " \\"  >> hlist.inc
2341                                printf " $sf" >> hlist.inc
2342                                ;;
2343                            flow)
2344                                echo    " \\"  >> ad_flow_files.inc
2345                                printf " $sf" >> ad_flow_files.inc
2346                                ;;
2347                        esac
2348                    fi
2349              fi              fi
2350          fi          fi
2351      done      done
# Line 1682  echo "" >> f90srclist.inc Line 2363  echo "" >> f90srclist.inc
2363  echo "" >> hlist.inc  echo "" >> hlist.inc
2364  echo "" >> ad_flow_files.inc  echo "" >> ad_flow_files.inc
2365    
2366  if test -e $MAKEFILE ; then  if test -f $MAKEFILE ; then
2367      mv -f $MAKEFILE "$MAKEFILE.bak"      mv -f $MAKEFILE "$MAKEFILE.bak"
2368  fi  fi
2369  echo "  Writing makefile: $MAKEFILE"  echo "  Writing makefile: $MAKEFILE"
# Line 1693  echo "#    $THISDATE" >> $MAKEFILE Line 2374  echo "#    $THISDATE" >> $MAKEFILE
2374  echo "# by the command:" >> $MAKEFILE  echo "# by the command:" >> $MAKEFILE
2375  echo "#    $0 $G2ARGS" >> $MAKEFILE  echo "#    $0 $G2ARGS" >> $MAKEFILE
2376  echo "# executed by:" >> $MAKEFILE  echo "# executed by:" >> $MAKEFILE
2377  echo "#    $USER@${THISHOSTNAME}:${THISCWD}" >> $MAKEFILE  echo "#    ${THISUSER}@${THISHOST}:${THISCWD}" >> $MAKEFILE
2378    
2379  EXE_AD=$EXECUTABLE"_ad"  EXE_AD=$EXECUTABLE"_ad"
2380  EXE_FTL=$EXECUTABLE"_ftl"  EXE_FTL=$EXECUTABLE"_ftl"
# Line 1739  ENABLED_PACKAGES = ${ENABLED_PACKAGES} Line 2420  ENABLED_PACKAGES = ${ENABLED_PACKAGES}
2420  DISABLED_PACKAGES = ${DISABLED_PACKAGES}  DISABLED_PACKAGES = ${DISABLED_PACKAGES}
2421    
2422  # These files are created by Makefile  # These files are created by Makefile
2423  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h  SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h BUILD_INFO.h
   
2424  EOF  EOF
2425    
2426  #  Note: figure out some way to add Hyades JAM libraries here  if test "x$EMBED_SRC" = xt ; then
2427        echo "EMBEDDED_FILES = EMBEDDED_FILES.h" >>$MAKEFILE
2428    else
2429        echo "EMBEDDED_FILES = " >>$MAKEFILE
2430    fi
2431    
2432    #  Note: figure out some way to add Hyades JAM libraries here
2433  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2434  # Unix ln (link)  # Unix ln (link)
2435  LN = ${LN}  LN = ${LN}
# Line 1758  KPP = ${KPP} Line 2443  KPP = ${KPP}
2443  FC = ${FC}  FC = ${FC}
2444  # Fortran compiler  # Fortran compiler
2445  F90C = ${F90C}  F90C = ${F90C}
2446    # C compiler
2447    CC = ${CC}
2448  # Link editor  # Link editor
2449  LINK = ${LINK} ${LDADD}  LINK = ${LINK} ${LDADD}
2450    
# Line 1780  CFLAGS = ${CFLAGS} Line 2467  CFLAGS = ${CFLAGS}
2467  NOOPTFILES = ${NOOPTFILES}  NOOPTFILES = ${NOOPTFILES}
2468  NOOPTFLAGS = ${NOOPTFLAGS}  NOOPTFLAGS = ${NOOPTFLAGS}
2469  # Flags and libraries needed for linking  # Flags and libraries needed for linking
2470  LIBS = ${LIBS} \$(XLIBS)  LIBS = ${LIBS}
2471  # Name of the Mekfile  # Name of the Mekfile
2472  MAKEFILE=${MAKEFILE}  MAKEFILE=${MAKEFILE}
2473    
# Line 1793  cat hlist.inc         >> $MAKEFILE Line 2480  cat hlist.inc         >> $MAKEFILE
2480  cat ad_flow_files.inc >> $MAKEFILE  cat ad_flow_files.inc >> $MAKEFILE
2481  echo >> $MAKEFILE  echo >> $MAKEFILE
2482  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE  echo 'F77FILES =  $(SRCFILES:.F=.'$FS')'      >> $MAKEFILE
2483  echo 'F90FILES =  $(F90SRCFILES:.F=.'$FS90')' >> $MAKEFILE  echo 'F90FILES =  $(F90SRCFILES:.F90=.'$FS90')' >> $MAKEFILE
2484  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE  echo 'OBJFILES =  $(SRCFILES:.F=.o) $(CSRCFILES:.c=.o) $(F90SRCFILES:.F90=.o)' >> $MAKEFILE
2485  echo >> $MAKEFILE  echo >> $MAKEFILE
2486  echo '.SUFFIXES:' >> $MAKEFILE  echo '.SUFFIXES:' >> $MAKEFILE
2487  echo '.SUFFIXES: .o .F .p .'$FS' .c .F90 .'$FS90 >> $MAKEFILE  echo '.SUFFIXES: .o .'$FS' .p .F .c .'$FS90' .F90' >> $MAKEFILE
2488  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc  rm -f srclist.inc csrclist.inc hlist.inc flist.tmp clist.tmp f90srclist.inc
2489  rm -f ad_flow_files.inc  rm -f ad_flow_files.inc
2490    
2491  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2492    
2493  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
2494  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES) \$(EMBEDDED_FILES)
2495          @echo Creating \$@ ...          @echo Creating \$@ ...
2496          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
2497  depend:  depend:
# Line 1813  depend: Line 2500  depend:
2500          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
2501          -rm -f makedepend.out          -rm -f makedepend.out
2502    
2503    lib: libmitgcmuv.a
2504    
2505    libmitgcmuv.a: \$(OBJFILES)
2506            ar rcv libmitgcmuv.a \$(OBJFILES)
2507            ar d   libmitgcmuv.a main.o
2508    
2509  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
2510    
2511  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
# Line 1822  output.txt: \$(EXECUTABLE) Line 2515  output.txt: \$(EXECUTABLE)
2515          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
2516    
2517  clean:  clean:
2518          -rm -rf *.o *.$FS *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template          -rm -rf *.p *.$FS90 *.mod ${RMFILES} work.{pc,pcl} *.template
2519            -rm -rf *.o
2520            -rm -rf *.$FS
2521  Clean:  Clean:
2522          @make clean          @make clean
2523          @make cleanlinks          @make cleanlinks
# Line 1833  CLEAN: Line 2528  CLEAN:
2528          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
2529          -find \$(EXEDIR) -name "*.data" -exec rm {} \;          -find \$(EXEDIR) -name "*.data" -exec rm {} \;
2530          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;          -find \$(EXEDIR) -name "fort.*" -exec rm {} \;
2531          -rm -f \$(EXECUTABLE) output.txt STD*          -rm -f \$(EXECUTABLE) \$(EXE_AD) *.txt STD* *diagnostics.log datetime
2532            -rm -rf mnc_test_*
2533    
2534  #eh3 Makefile: makefile  #eh3 Makefile: makefile
2535  makefile:  makefile:
# Line 1841  makefile: Line 2537  makefile:
2537  cleanlinks:  cleanlinks:
2538          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
2539    
2540  # Special targets ($SPECIAL_FILES) which are create by make  # Special targets (SPECIAL_FILES) which are create by make
2541  ${PACKAGES_DOT_H}:  ${PACKAGES_DOT_H}:
2542          @echo Creating \$@ ...          @echo Creating \$@ ...
2543          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
# Line 1852  FC_NAMEMANGLE.h: Line 2548  FC_NAMEMANGLE.h:
2548          @echo Creating \$@ ...          @echo Creating \$@ ...
2549          echo "$FC_NAMEMANGLE" > \$@          echo "$FC_NAMEMANGLE" > \$@
2550    
2551    BUILD_INFO.h:
2552            @echo Creating \$@ ...
2553    EOF
2554    
2555    test ! "x$THISVER" = x  && echo "       -echo \"#define THISVER '$THISVER'\" > \$@"   >> $MAKEFILE
2556    test ! "x$THISUSER" = x && echo "       -echo \"#define THISUSER '$THISUSER'\" >> \$@" >> $MAKEFILE
2557    test ! "x$THISDATE" = x && echo "       -echo \"#define THISDATE '$THISDATE'\" >> \$@" >> $MAKEFILE
2558    test ! "x$THISHOST" = x && echo "       -echo \"#define THISHOST '$THISHOST'\" >> \$@" >> $MAKEFILE
2559    
2560    if test "x$EMBED_SRC" = xt ; then
2561        cat >>$MAKEFILE <<EOF
2562    
2563    decode_files.o : EMBEDDED_FILES.h
2564    
2565    ##  \$(F77FILES)
2566    all_fF.tar.gz : \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2567            @echo Creating \$@ ...
2568            -tar -hcf all_fF.tar \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(F77FILES) Makefile
2569            -rm -f all_fF.tar.gz
2570            -gzip all_fF.tar
2571    
2572    EMBEDDED_FILES.h : all_fF.tar.gz
2573            @echo Creating \$@ ...
2574            -\${ROOTDIR}/tools/embed_encode/encode_files EMBEDDED_FILES.h all_fF.tar.gz
2575    
2576    EOF
2577    fi
2578    
2579    cat >>$MAKEFILE <<EOF
2580    
2581  # The normal chain of rules is (  .F - .$FS - .o  )  # The normal chain of rules is (  .F - .$FS - .o  )
2582    
2583  %.o : %.F  ## This nullifies any default implicit rules concerning these two file types:
2584    ## %.o : %.F
2585    
2586  .F.$FS:  .F.$FS:
2587          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
2588  .$FS.o:  .$FS.o:
2589          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<          \$(FC) \$(FFLAGS) \$(FOPTIM) -c \$<
2590  .F90.$FS90:  .F90.o:  
         \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@  
 .$FS90.o:  
2591          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<          \$(F90C) \$(F90FLAGS) \$(F90OPTIM) -c \$<
2592  .c.o:  .c.o:
2593          \$(CC) \$(CFLAGS) -c \$<          \$(CC) \$(CFLAGS) \$(DEFINES) \$(INCLUDES) -c \$<
2594    
2595  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain  # Special exceptions that use the ( .F - .p - .$FS - .o ) rule-chain
2596  .F.p:  .F.p:
# Line 1889  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF Line 2614  ad_vars="$ad_vars FTL_TAMC_FLAGS FTL_TAF
2614  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"  ad_vars="$ad_vars SVD_TAMC_FLAGS SVD_TAF_FLAGS"
2615  for i in $ad_vars ; do  for i in $ad_vars ; do
2616      name=$i      name=$i
2617      t1="t2=\$"`echo $i`      t1="t2=\$"`echo "$i"`
2618      eval $t1      eval $t1
2619      printf "%-20s = " $name >> $MAKEFILE      printf "%-20s = " $name >> $MAKEFILE
2620      echo $t2 >> $MAKEFILE      echo "$t2" | sed -e 's| \+| |g' >> $MAKEFILE
2621  done  done
2622    
2623  echo "  Add the source list for AD code generation"  echo "  Add the source list for AD code generation"
# Line 1909  rm -f ad_files Line 2634  rm -f ad_files
2634  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
2635    
2636  # ... AD ...  # ... AD ...
2637  adall: ad_taf  adall: \$(EXE_AD)
2638  adtaf: ad_taf_output.f  adtaf: ad_taf_output.$FS
2639  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.$FS
2640    
2641  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2642          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
2643          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
2644          -rm -f ad_config.template          -rm -f ad_config.template
2645          @make \$(F77FILES)          @make \$(F77FILES)
2646          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2647          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.$FS
2648    
2649  ad_taf_output.f: ad_input_code.f  ad_taf_output.$FS: ad_input_code.$FS
2650          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2651          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2652    
2653  adtafonly:  adtafonly:
2654          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.$FS
2655          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.$FS
2656    
2657  ad_taf: ad_taf_output.o \$(OBJFILES)  \${EXE_AD}: ad_taf_output.o \$(OBJFILES)
2658          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o \${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
2659    
2660  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.$FS: ad_input_code.$FS
2661          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.$FS
2662          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.$FS
2663    
2664  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
2665          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
2666    
2667    adonlyfwd:
2668            patch < \$(TOOLSDIR)/ad_taf_output.f.onlyfwd.diff
2669    
2670    adtrick:
2671            patch < \$(TOOLSDIR)/ad_taf_output.f.adtrick.diff
2672    
2673  # ... FTL ...  # ... FTL ...
2674  ftlall: ftl_taf  ftlall: ftl_taf
2675  ftltaf: ftl_taf_output.f  ftltaf: ftl_taf_output.$FS
2676  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.$FS
2677    
2678  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.$FS: \$(AD_FILES) \$(HEADERFILES)
2679          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template          @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2680          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2681          -rm -f ftl_config.template          -rm -f ftl_config.template
2682          @make \$(F77FILES)          @make \$(F77FILES)
2683          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
2684          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.$FS
2685    
2686  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.$FS: ftl_input_code.$FS
2687          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2688          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2689    
2690  ftltafonly:  ftltafonly:
2691          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.$FS
2692          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.$FS
2693    
2694  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
2695          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
2696    
2697  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.$FS: ftl_input_code.$FS
2698          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.$FS
2699          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.$FS | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.$FS
2700    
2701  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
2702          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
2703    
2704    
2705  # ... SVD ...  # ... SVD ...
2706  svdtaf: ad_taf_output.f ftl_taf_output.f  svdtaf: ad_taf_output.$FS ftl_taf_output.$FS
2707  svdall: svd_taf          @echo "--->>> Only ran TAF to generate SVD code!    <<<---"
2708            @echo "--->>> Do make svdall afterwards to compile. <<<---"
2709    svdall: svd_touch svd_taf
2710    
2711  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)  svd_taf: \$(OBJFILES)
2712          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
2713    
2714            @echo "--->>> Only COMPILE svd code! <<<---"
2715            @echo "--->>> Assumes you previously <<<---"
2716            @echo "--->>> did make svdtaf        <<<---"
2717    
2718    svd_touch:
2719            @echo "--->>> Only COMPILE svd code! <<<---"
2720            @echo "--->>> Assumes you previously <<<---"
2721            @echo "--->>> did make svdtaf        <<<---"
2722            touch ad_taf_output.$FS ftl_taf_output.$FS
2723            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ad_taf_output.$FS
2724            \$(FC) \$(FFLAGS) \$(FOPTIM) -c ftl_taf_output.$FS
2725            @$BASH\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
2726            cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
2727            -rm -f ftl_config.template
2728    
2729  #=========================================  #=========================================
2730    

Legend:
Removed from v.1.82  
changed lines
  Added in v.1.162

  ViewVC Help
Powered by ViewVC 1.1.22